Description

Currently, we have pairs of non-predicate and predicate methods like String#match and String#match?. Along this line, I propose the

following. They are brain-friendly, and make programmers happier by saving them from terminology hell.

1. Since by #19588, Comparable#clamp's behavior is made the same as Range#cover? for range arguments, alias Range#cover?

as Range#clamp?.

2. Synchronize the specification of Comparable#between? with Comparable#clamp, i.e.,

a. Allow Comparable#between? to take a range argument, and

b. Allow Comparable#between? to take nil as either or both of its arguments, or as either or both ends of its range argument.

3. Alias Comparable#between? as Comparable#clamped?

History

#1 - 04/14/2023 12:53 PM - sawa (Tsuyoshi Sawada)

- Description updated

#2 - 04/14/2023 12:54 PM - sawa (Tsuyoshi Sawada)

- Description updated

#3 - 04/14/2023 02:40 PM - nobu (Nobuyoshi Nakada)

Since the method clamp makes a value covered by a range from an uncovered value, clamp? doesn't feel same as cover? or between?, to me.

Extending Comparable#between? sounds nice.

#4 - 07/12/2023 05:14 AM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/8056

#5 - 07/13/2023 09:39 AM - matz (Yukihiro Matsumoto)

- Status changed from Open to Closed

This issue includes multiple proposals, and the rationale is only explained 'brain-friendly', which may vary person to person.

Please make sure one issue contains only one proposal, with subjective rationale or real world use-cases.

For this particular case, I am not convinced by any of the proposals.

Matz.
